precision highp float;
precision highp int;

uniform sampler2D s_cc3Texture2D;

uniform float u_weights[61];
uniform int u_radius;
uniform vec2 u_dir;
uniform float u_intensity;
uniform float u_resolution;

varying vec2 v_texCoord;

void main() {
    vec4 original = texture2D(s_cc3Texture2D, v_texCoord);
    vec2 tc = v_texCoord;
    float blur = 1.0/u_resolution;
    vec4 sum = vec4(0.0);
    float weight = 0.0;
    float hstep = u_dir.x;
    float vstep = u_dir.y;
    for (int i=-u_radius; i<=u_radius; i++) {
        weight = u_weights[i+u_radius];
        sum += texture2D(s_cc3Texture2D, vec2(tc.x + float(i)*blur*hstep, tc.y + float(i)*blur*vstep))*weight;
    }

    gl_FragColor = sum;
}
