//#define PROGRAMMABLE_BLENDING


#if !defined(PREFIX_SHADER)
#define PREFIX_SHADER

#if defined(GL_EXT_shader_texture_lod)
    #extension GL_EXT_shader_texture_lod : enable
#endif

#if defined(PROGRAMMABLE_BLENDING) && defined(GL_EXT_shader_framebuffer_fetch)
    #extension GL_EXT_shader_framebuffer_fetch : require
#endif

precision highp float;

#if __VERSION__ >= 300
    #define ATTRIBUTE in
    #define VARYING_IN in
    #define VARYING_OUT out
    #define texture2D texture

    #if defined(FRAGMENT_SHADER)
        // This is blocked by PROGRAMMABLE_BLENDING so that we do not unnecessarily read framebuffer data
        #if defined(PROGRAMMABLE_BLENDING) && defined(GL_EXT_shader_framebuffer_fetch)
            layout(location = 0) inout vec4 destColor; // declared inout, the variable will contain framebuffer data
        #else
            layout(location = 0) out vec4 destColor;
        #endif
        #define gl_FragColor destColor
    #endif
#else
    #define ATTRIBUTE attribute
    #define VARYING_IN varying
    #define VARYING_OUT varying
#endif

#endif
