precision highp float;

uniform sampler2D un_texture2D;
uniform float un_applyTexture;

uniform float un_opacity;
varying vec2 v_texCoord;
varying vec4 v_color;

void main() {
    vec4 textureColor = texture2D(un_texture2D, v_texCoord);
    vec4 color = mix(vec4(1), textureColor, un_applyTexture);
    vec4 diffuseColor = v_color * color;
    gl_FragColor = diffuseColor;
    gl_FragColor.a *= un_opacity;
}
